Index: orxonox/branches/physics/src/lib/graphics/importer/model.cc
===================================================================
--- orxonox/branches/physics/src/lib/graphics/importer/model.cc	(revision 3866)
+++ orxonox/branches/physics/src/lib/graphics/importer/model.cc	(revision 3953)
@@ -23,160 +23,21 @@
 #include "array.h"
 #include "vector.h"
+#include "list.h"
 
 using namespace std;
 
-/**
-   \brief Creates a 3D-Model.
-
-   This only initializes a 3D-Model, but does not cleanup the Faces.
-*/
-Model::Model(void)
-{
-  this->initialize();
-}
-
+//////////////////
+// DE-CONSTRUCT //
+//////////////////
 /**
    \brief Creates a 3D-Model. and assigns it a Name.
 */
-Model::Model(char* modelName)
-{
-  this->initialize();
+Model::Model(const char* modelName, MODEL_TYPE type)
+{
+  PRINTF(4)("new 3D-Model is being created\n"); 
+  this->name = NULL;
   this->setName(modelName);
-}
-
-/**
-   \brief deletes an Model.
-
-   Looks if any from model allocated space is still in use, and if so deleted it.
-*/
-Model::~Model(void)
-{
-  PRINTF(4)("Deleting Model ");
-  if (this->name)
-    {
-      PRINT(4)("%s\n", this->name);
-      delete []this->name;
-    }
-  else
-      PRINT(4)("\n");
-
-  PRINTF(4)("Deleting display Lists.\n");
-  Group* walker = this->firstGroup;
-  while (walker != NULL)
-    {
-      glDeleteLists (walker->listNumber, 1);
-      Group* delWalker = walker;
-      walker = walker->next;
-      delete delWalker;
-    }
-
-  PRINTF(4)("Deleting Materials.\n");
-  if (this->material)
-    delete this->material;
-}
-
-/**
-   \brief Finalizes an Object. This can be done outside of the Class.
-*/
-void Model::finalize(void)
-{
-  this->importToGL ();
-  
-  this->cleanup();
-
-  this->finalized = true;
-}
-
-/**
-   \brief Draws the Models of all Groups.
-   It does this by just calling the Lists that must have been created earlier.
-*/
-void Model::draw (void) const
-{
-  PRINTF(4)("drawing the 3D-Models\n"); 
-  Group* walker = this->firstGroup;
-  while (walker != NULL)
-    {
-      PRINTF(5)("Drawing model %s\n", walker->name);
-      glCallList (walker->listNumber);
-      walker = walker->next;
-    }
-}
-
-/**
-   \brief Draws the Model number groupNumber
-   \param groupNumber The number of the group that will be displayed.
-
-   It does this by just calling the List that must have been created earlier.
-*/
-void Model::draw (int groupNumber) const 
-{
-  if (groupNumber >= this->groupCount)
-    {
-      PRINTF(2)("You requested model number %i, but this File only contains of %i Models.\n", groupNumber-1, this->groupCount);
-      return;
-    }
-  PRINTF(4)("drawing the requested 3D-Models if found.\n"); 
-  Group* walker = this->firstGroup;
-  int counter = 0;
-  while (walker != NULL)
-    {
-      if (counter == groupNumber)
-	{
-	  PRINTF(2)("Drawing model number %i named %s\n", counter, walker->name);
-	  glCallList (walker->listNumber);
-	  return;
-	}
-      ++counter;
-      walker = walker->next;
-    }
-  PRINTF(2)("Model number %i in %s not Found.\n", groupNumber, this->name);
-  return;
-
-}
-
-/**
-   \brief Draws the Model with a specific groupName
-   \param groupName The name of the group that will be displayed.
-
-   It does this by just calling the List that must have been created earlier.
-*/
-void Model::draw (char* groupName) const
-{
-  PRINTF(4)("drawing the requested 3D-Models if found.\n"); 
-  Group* walker = this->firstGroup;
-  while (walker != NULL)
-    {
-      if (!strcmp(walker->name, groupName))
-	{
-	  PRINTF(4)("Drawing model %s\n", walker->name);
-	  glCallList (walker->listNumber);
-	  return;
-	}
-      walker = walker->next;
-    }
-  PRINTF(2)("Model Named %s in %s not Found.\n", groupName, this->name);
-  return;
-}
-
-/**
-   \returns Count of the Models in this File
-*/
-int Model::getGroupCount (void) const
-{
-  return this->groupCount;
-}
-
-/**
-    \brief initializes the Model.
-
-    This Function initializes all the needed arrays, Lists and clientStates.
-    It also defines default values.
-*/
-bool Model::initialize (void)
-{
-  PRINTF(4)("new 3D-Model is being created\n"); 
-
-  this->name = NULL;
+  this->type = type;
+
   this->finalized = false;
   // setting the start group;
@@ -187,5 +48,4 @@
   this->initGroup (this->currentGroup);
   this->scaleFactor = 1;
-  this->material = new Material();
 
   this->vertices = new Array();
@@ -193,7 +53,155 @@
   this->normals = new Array();
 
-  return true;
-}
-
+  this->materialList = new tList<Material>;
+
+  if (this->type == MODEL_VERTEX_ARRAY)
+    glEnableClientState(GL_VERTEX_ARRAY | GL_NORMAL_ARRAY | GL_TEXTURE_COORD_ARRAY);
+}
+
+/**
+   \brief deletes an Model.
+
+   Looks if any from model allocated space is still in use, and if so deleted it.
+*/
+Model::~Model(void)
+{
+  PRINTF(4)("Deleting Model ");
+  if (this->name)
+    {
+      PRINT(4)("%s\n", this->name);
+      delete []this->name;
+    }
+  else
+      PRINT(4)("\n");
+
+  PRINTF(5)("Deleting display Lists.\n");
+  Group* walker = this->firstGroup;
+  while (walker != NULL)
+    {
+      glDeleteLists (walker->listNumber, 1);
+      Group* delWalker = walker;
+      walker = walker->next;
+      delete delWalker;
+    }
+
+  // deleting Arrays
+  this->deleteArrays();
+
+  // deleting the MaterialList
+  PRINTF(5)("Deleting Materials.\n");
+  tIterator<Material>* tmpIt = this->materialList->getIterator();
+  Material* material = tmpIt->nextElement();
+  while(material)
+    {
+      delete material;
+      material = tmpIt->nextElement();
+    }
+  delete tmpIt;
+  delete materialList;
+}
+
+/**
+   \brief Finalizes an Object. This can be done outside of the Class.
+*/
+void Model::finalize(void)
+{
+  // this creates the display List.
+  this->importToDisplayList();
+  
+
+  // deletes everything we allocated.
+  if (this->type == MODEL_DISPLAY_LIST)
+    this->deleteArrays();
+  this->cleanup();
+
+  this->finalized = true;
+}
+
+//////////
+// DRAW //
+//////////
+/**
+   \brief Draws the Models of all Groups.
+   It does this by just calling the Lists that must have been created earlier.
+*/
+void Model::draw (void) const
+{
+  PRINTF(4)("drawing the 3D-Models\n"); 
+  Group* walker = this->firstGroup;
+  while (walker != NULL)
+    {
+      PRINTF(5)("Drawing model %s\n", walker->name);
+      glCallList (walker->listNumber);
+      walker = walker->next;
+    }
+}
+
+/**
+   \brief Draws the Model number groupNumber
+   \param groupNumber The number of the group that will be displayed.
+
+   It does this by just calling the List that must have been created earlier.
+*/
+void Model::draw (int groupNumber) const 
+{
+  if (groupNumber >= this->groupCount)
+    {
+      PRINTF(2)("You requested model number %i, but this File only contains of %i Models.\n", groupNumber-1, this->groupCount);
+      return;
+    }
+  PRINTF(4)("drawing the requested 3D-Models if found.\n"); 
+  Group* walker = this->firstGroup;
+  int counter = 0;
+  while (walker != NULL)
+    {
+      if (counter == groupNumber)
+	{
+	  PRINTF(4)("Drawing model number %i named %s\n", counter, walker->name);
+	  glCallList (walker->listNumber);
+	  return;
+	}
+      ++counter;
+      walker = walker->next;
+    }
+  PRINTF(2)("Model number %i in %s not Found.\n", groupNumber, this->name);
+  return;
+
+}
+
+/**
+   \brief Draws the Model with a specific groupName
+   \param groupName The name of the group that will be displayed.
+
+   It does this by just calling the List that must have been created earlier.
+*/
+void Model::draw (char* groupName) const
+{
+  PRINTF(4)("drawing the requested 3D-Models if found.\n"); 
+  Group* walker = this->firstGroup;
+  while (walker != NULL)
+    {
+      if (!strcmp(walker->name, groupName))
+	{
+	  PRINTF(4)("Drawing model %s\n", walker->name);
+	  glCallList (walker->listNumber);
+	  return;
+	}
+      walker = walker->next;
+    }
+  PRINTF(2)("Model Named %s in %s not Found.\n", groupName, this->name);
+  return;
+}
+
+/**
+   \returns Count of the Models in this File
+*/
+int Model::getGroupCount (void) const
+{
+  return this->groupCount;
+}
+
+//////////
+// INIT //
+//////////
 /**
    \brief sets a name to the Model
@@ -204,7 +212,13 @@
   if (this->name) 
     delete this->name;
-  this->name = new char[strlen(name)+1];
-  strcpy(this->name, name);
-}
+  if (name)
+    {
+      this->name = new char[strlen(name)+1];
+      strcpy(this->name, name);
+    }
+  else 
+    this->name = NULL;
+}
+
 /**
    \brief initializes a new Group model
@@ -244,11 +258,8 @@
 
 /**
-   \brief finalizes an Model.
-   This funcion is needed, to delete all the Lists, and arrays that are no more needed because they are already imported into openGL. This will be applied at the end of the importing Process.
-*/
-bool Model::cleanup(void)
-{
-  PRINTF(4)("cleaning up the 3D-Model to save Memory.\n");
-
+   \brief deletes all the arrays
+*/
+bool Model::deleteArrays(void)
+{
   if (this->vertices)
     delete this->vertices;
@@ -257,5 +268,16 @@
   if (this->normals)
     delete this->normals;
-
+  this->vertices = NULL;
+  this->vTexture = NULL;
+  this->normals = NULL;
+}
+
+/**
+   \brief finalizes an Model.
+   This funcion is needed, to delete all the Lists, and arrays that are no more needed because they are already imported into openGL. This will be applied at the end of the importing Process.
+*/
+bool Model::cleanup(void)
+{
+  PRINTF(4)("cleaning up the 3D-Model to save Memory.\n");
   this->cleanupGroup(this->firstGroup);
   return true; 
@@ -299,7 +321,5 @@
       delete face->next;
     }
-      
-}
-
+}
 
 /**
@@ -316,4 +336,58 @@
 }
 
+//////////
+// MESH //
+//////////
+/**
+   \brief adds a new Material to the Material List
+   \param material the Material to add
+   \returns the added material
+
+   !! beware the Material will be deleted when the Model gets deleted
+*/
+Material* Model::addMaterial(Material* material)
+{
+  this->materialList->add(material);
+  return material;
+}
+
+/**
+   \brief adds a new Material to the Material List
+   \param material the name of the Material to add
+   \returns the added material
+*/
+Material* Model::addMaterial(const char* materialName)
+{
+  
+  Material* newMat = new Material();
+  newMat->setName(materialName);
+
+  // adding material to the List of materials
+  this->materialList->add(newMat);  
+  return newMat;
+}
+
+/**
+   \brief finds a Material by its name and returns it
+   \param materialName the Name of the material to search for.
+   \returns the Material if found, NULL otherwise
+*/
+Material* Model::findMaterialByName(const char* materialName)
+{
+  tIterator<Material>* tmpIt = this->materialList->getIterator();
+  Material* material = tmpIt->nextElement();
+  while(material)
+    {
+      if (!strcmp(material->getName(), materialName))
+	{
+	  delete tmpIt;
+	  return material;
+	}
+      material = tmpIt->nextElement();
+    }
+  delete tmpIt;
+  return NULL;
+}
+
 /**
    \brief parses a group String
@@ -323,5 +397,5 @@
    With it you should be able to import .obj-files with more than one Models inside. 
 */
-bool Model::addGroup (char* groupString)
+bool Model::addGroup (const char* groupString)
 {
   PRINTF(5)("Read Group: %s.\n", groupString);
@@ -339,5 +413,4 @@
     }
   ++this->groupCount;
-
 }
 
@@ -348,5 +421,5 @@
    If a vertex line is found this function will inject it into the vertex-Array
 */
-bool Model::addVertex (char* vertexString)
+bool Model::addVertex (const char* vertexString)
 {
   float subbuffer1;
@@ -366,5 +439,5 @@
    
 */
-bool Model::addVertex(const float x, const float y, const float z)
+bool Model::addVertex(float x, float y, float z)
 {
   PRINTF(5)("reading in a vertex: %f %f %f\n", x, y, z);
@@ -374,4 +447,67 @@
 
 /**
+   \brief parses a vertexNormal-String
+   \param normalString The String that will be parsed.
+
+   If a vertexNormal line is found this function will inject it into the vertexNormal-Array
+*/
+bool Model::addVertexNormal (const char* normalString)
+{
+  float subbuffer1;
+  float subbuffer2;
+  float subbuffer3;
+  sscanf (normalString, "%f %f %f", &subbuffer1, &subbuffer2, &subbuffer3);
+  PRINTF(5)("found vertex-Normal %f, %f, %f\n", &subbuffer1,&subbuffer2,&subbuffer3);
+  this->normals->addEntry(subbuffer1, subbuffer2, subbuffer3);
+  return true;
+}
+
+/**
+   \brief adds a VertexNormal.
+   \param x The x coordinate of the Normal.
+   \param y The y coordinate of the Normal.
+   \param z The z coordinate of the Normal.
+
+   If a vertexNormal line is found this function will inject it into the vertexNormal-Array
+*/
+bool Model::addVertexNormal(float x, float y, float z)
+{
+  PRINTF(5)("found vertex-Normal %f, %f, %f\n", x, y, z);
+  this->normals->addEntry(x, y, z);
+}
+
+/**
+   \brief parses a vertexTextureCoordinate-String
+   \param vTextureString The String that will be parsed.
+
+   If a vertexTextureCoordinate line is found,
+   this function will inject it into the vertexTexture-Array
+*/
+bool Model::addVertexTexture (const char* vTextureString)
+{
+  float subbuffer1;
+  float subbuffer2;
+  sscanf (vTextureString, "%f %f", &subbuffer1, &subbuffer2);
+  PRINTF(5)("found vertex-Texture %f, %f\n", &subbuffer1, &subbuffer2);
+  this->vTexture->addEntry(subbuffer1);
+  this->vTexture->addEntry(subbuffer2);
+  return true;
+}
+
+/**
+   \brief adds a Texture Coordinate
+   \param u The u coordinate of the TextureCoordinate.
+   \param v The y coordinate of the TextureCoordinate.
+
+   If a TextureCoordinate line is found this function will inject it into the TextureCoordinate-Array
+*/
+bool Model::addVertexTexture(float u, float v)
+{
+  PRINTF(5)("found vertex-Texture %f, %f\n", u, v);
+  this->vTexture->addEntry(u);
+  this->vTexture->addEntry(v);
+}
+
+/**
    \brief parses a face-string
    \param faceString The String that will be parsed.
@@ -379,5 +515,5 @@
    If a face line is found this function will add it to the glList.
 */
-bool Model::addFace (char* faceString)
+bool Model::addFace (const char* faceString)
 {
   if (this->currentGroup->faceCount >0)
@@ -441,5 +577,5 @@
    \param type 0: vertex only, 1: vertex and normal, 2: vertex and Texture, 3 vertex, normal and texture
 */
-bool Model::addFace(const float faceElemCount, int type, ...)
+bool Model::addFace(int faceElemCount, VERTEX_FORMAT type, ...)
 {
    if (this->currentGroup->faceCount > 0)
@@ -472,84 +608,14 @@
 
 /**
-   \brief parses a vertexNormal-String
-   \param normalString The String that will be parsed.
-
-   If a vertexNormal line is found this function will inject it into the vertexNormal-Array
-*/
-bool Model::addVertexNormal (char* normalString)
-{
-  float subbuffer1;
-  float subbuffer2;
-  float subbuffer3;
-  sscanf (normalString, "%f %f %f", &subbuffer1, &subbuffer2, &subbuffer3);
-  PRINTF(5)("found vertex-Normal %f, %f, %f\n", &subbuffer1,&subbuffer2,&subbuffer3);
-  this->normals->addEntry(subbuffer1, subbuffer2, subbuffer3);
-  return true;
-}
-
-/**
-   \brief adds a VertexNormal.
-   \param x The x coordinate of the Normal.
-   \param y The y coordinate of the Normal.
-   \param z The z coordinate of the Normal.
-
-   If a vertexNormal line is found this function will inject it into the vertexNormal-Array
-*/
-bool Model::addVertexNormal(const float x, const float y, const float z)
-{
-  PRINTF(3)("found vertex-Normal %f, %f, %f\n", x, y, z);
-  this->normals->addEntry(x, y, z);
-}
-
-/**
-   \brief parses a vertexTextureCoordinate-String
-   \param vTextureString The String that will be parsed.
-
-   If a vertexTextureCoordinate line is found,
-   this function will inject it into the vertexTexture-Array
-*/
-bool Model::addVertexTexture (char* vTextureString)
-{
-  float subbuffer1;
-  float subbuffer2;
-  sscanf (vTextureString, "%f %f", &subbuffer1, &subbuffer2);
-  PRINTF(5)("found vertex-Texture %f, %f\n", &subbuffer1, &subbuffer2);
-  this->vTexture->addEntry(subbuffer1);
-  this->vTexture->addEntry(subbuffer2);
-  return true;
-}
-
-/**
-   \brief adds a Texture Coordinate
-   \param u The u coordinate of the TextureCoordinate.
-   \param v The y coordinate of the TextureCoordinate.
-
-   If a TextureCoordinate line is found this function will inject it into the TextureCoordinate-Array
-*/
-bool Model::addVertexTexture(const float u, const float v)
-{
-  PRINTF(3)("found vertex-Texture %f, %f\n", u, v);
-  this->vTexture->addEntry(u);
-  this->vTexture->addEntry(v);
-}
-
-/**
    \brief Function that selects a material, if changed in the obj file.
    \param matString the Material that will be set.
 */
-bool Model::addUseMtl (char* matString)
-{
-  /*
-  if (!this->mtlFileName)
-    {
-      PRINTF(4)("Not using new defined material, because no mtlFile found yet\n");
-      return false;
-    }
-  */      
+bool Model::setMaterial(const char* matString)
+{
   if (this->currentGroup->faceCount > 0)
     this->currentGroup->currentFace = this->currentGroup->currentFace->next = new Face;
   this->initFace (this->currentGroup->currentFace);
   
-  this->currentGroup->currentFace->material = material->search(matString);
+  this->currentGroup->currentFace->material = this->findMaterialByName(matString);
 
   if (this->currentGroup->faceCount == 0)
@@ -561,5 +627,5 @@
    \param mtl the Material that will be set.
 */
-bool Model::addUseMtl (Material* mtl)
+bool Model::setMaterial(Material* mtl)
 {
   if (this->currentGroup->faceCount > 0)
@@ -574,9 +640,87 @@
 
 /**
+   \brief A routine that is able to create normals.
+
+   The algorithm does the following:
+   1. It calculates creates Vectors for each normale, and sets them to zero.
+   2. It then Walks through a) all the Groups b) all the Faces c) all the FaceElements
+   3. It searches for a points two neighbours per Face, takes Vecotrs to them calculates FaceNormals and adds it to the Points Normal.
+   4. It goes through all the normale-Points and calculates the VertexNormale and includes it in the normals-Array.
+*/
+bool Model::buildVertexNormals ()
+{  
+  PRINTF(4)("Normals are being calculated.\n");
+
+  Vector* normArray = new Vector [vertices->getCount()/3];
+  for (int i=0; i<vertices->getCount()/3;i++)
+    normArray[i] = Vector(.0,.0,.0);
+  
+  int firstTouch;
+  int secondTouch;
+  Vector prevV;
+  Vector nextV;
+  Vector curV;
+
+  Group* tmpGroup = firstGroup;
+  while (tmpGroup)
+    {
+      Face* tmpFace = tmpGroup->firstFace;
+      while (tmpFace)
+	{
+	  if (tmpFace->firstElem)
+	    {
+	      FaceElement* firstElem = tmpFace->firstElem;
+	      FaceElement* prevElem;
+	      FaceElement* curElem = firstElem;
+	      FaceElement* nextElem;
+	      FaceElement* lastElem;
+	      // find last Element of the Chain. !! IMPORTANT:the last Element of the Chain must point to NULL, or it will resolv into an infinity-loop.
+	      while (curElem)
+		{
+		  prevElem = curElem;
+		  curElem = curElem->next;
+		}
+	      lastElem = prevElem;
+	      
+	      curElem = firstElem;
+	      for (int j=0; j<tmpFace->vertexCount; j++)
+		{
+		  if (!(nextElem = curElem->next))
+		    nextElem = firstElem;
+		  curElem->normalNumber = curElem->vertexNumber;
+		  
+		  curV = Vector (vertices->getArray()[curElem->vertexNumber*3], vertices->getArray()[curElem->vertexNumber*3+1], vertices->getArray()[curElem->vertexNumber*3+2]);
+		  prevV = Vector (vertices->getArray()[prevElem->vertexNumber*3], vertices->getArray()[prevElem->vertexNumber*3+1], vertices->getArray()[prevElem->vertexNumber*3+2]) - curV;
+		  nextV = Vector (vertices->getArray()[nextElem->vertexNumber*3], vertices->getArray()[nextElem->vertexNumber*3+1], vertices->getArray()[nextElem->vertexNumber*3+2]) - curV;
+		  normArray[curElem->vertexNumber] = normArray[curElem->vertexNumber] + nextV.cross(prevV);
+
+		  prevElem = curElem;
+		  curElem = curElem->next;
+		}
+	    }
+	  tmpFace = tmpFace->next;
+	}
+      tmpGroup = tmpGroup->next;
+    }
+
+  for (int i=0; i<vertices->getCount()/3;i++)
+    {
+      normArray[i].normalize();
+      PRINTF(5)("Found Normale number %d: (%f; %f, %f).\n", i, normArray[i].x, normArray[i].y, normArray[i].z);
+      
+      this->normals->addEntry(normArray[i].x, normArray[i].y, normArray[i].z);
+
+    }
+  delete []normArray; 
+}
+
+////////////
+// openGL //
+////////////
+/**
    \brief reads and includes the Faces/Materials into the openGL state Machine
 */
-bool Model::importToGL (void)
-{
-
+bool Model::importToDisplayList(void)
+{
   // finalize the Arrays
   this->vertices->finalizeArray();
@@ -667,4 +811,25 @@
 
 /**
+   \brief reads and includes the Faces/Materials into the openGL state Machine
+*/
+bool Model::importToVertexArray(void)
+{
+  // finalize the Arrays
+  this->vertices->finalizeArray();
+  this->vTexture->finalizeArray();
+  if (normals->getCount() == 0) // vertices-Array must be built for this
+    this->buildVertexNormals();
+  this->normals->finalizeArray();
+
+  this->currentGroup = this->firstGroup;
+  glVertexPointer(3, GL_FLOAT, 0, this->vertices->getArray());
+  glNormalPointer(3, 0, this->normals->getArray());
+  glTexCoordPointer(2, GL_FLOAT, 0, this->vTexture->getArray());
+
+}
+
+
+
+/**
    \brief Adds a Face-element (one vertex of a face) with all its information. 
    \param elem The FaceElement to add to the OpenGL-environment.
@@ -688,83 +853,4 @@
 
 }
-
-/**
-   \brief A routine that is able to create normals.
-
-   The algorithm does the following:
-   1. It calculates creates Vectors for each normale, and sets them to zero.
-   2. It then Walks through a) all the Groups b) all the Faces c) all the FaceElements
-   3. It searches for a points two neighbours per Face, takes Vecotrs to them calculates FaceNormals and adds it to the Points Normal.
-   4. It goes through all the normale-Points and calculates the VertexNormale and includes it in the normals-Array.
-*/
-bool Model::buildVertexNormals ()
-{
-  
-  PRINTF(4)("Normals are being calculated.\n");
-
-  Vector* normArray = new Vector [vertices->getCount()/3];
-  for (int i=0; i<vertices->getCount()/3;i++)
-    normArray[i] = Vector(.0,.0,.0);
-  
-  int firstTouch;
-  int secondTouch;
-  Vector prevV;
-  Vector nextV;
-  Vector curV;
-
-  Group* tmpGroup = firstGroup;
-  while (tmpGroup)
-    {
-      Face* tmpFace = tmpGroup->firstFace;
-      while (tmpFace)
-	{
-	  if (tmpFace->firstElem)
-	    {
-	      FaceElement* firstElem = tmpFace->firstElem;
-	      FaceElement* prevElem;
-	      FaceElement* curElem = firstElem;
-	      FaceElement* nextElem;
-	      FaceElement* lastElem;
-	      // find last Element of the Chain. !! IMPORTANT:the last Element of the Chain must point to NULL, or it will resolv into an infinity-loop.
-	      while (curElem)
-		{
-		  prevElem = curElem;
-		  curElem = curElem->next;
-		}
-	      lastElem = prevElem;
-	      
-	      curElem = firstElem;
-	      for (int j=0; j<tmpFace->vertexCount; j++)
-		{
-		  if (!(nextElem = curElem->next))
-		    nextElem = firstElem;
-		  curElem->normalNumber = curElem->vertexNumber;
-		  
-		  curV = Vector (vertices->getArray()[curElem->vertexNumber*3], vertices->getArray()[curElem->vertexNumber*3+1], vertices->getArray()[curElem->vertexNumber*3+2]);
-		  prevV = Vector (vertices->getArray()[prevElem->vertexNumber*3], vertices->getArray()[prevElem->vertexNumber*3+1], vertices->getArray()[prevElem->vertexNumber*3+2]) - curV;
-		  nextV = Vector (vertices->getArray()[nextElem->vertexNumber*3], vertices->getArray()[nextElem->vertexNumber*3+1], vertices->getArray()[nextElem->vertexNumber*3+2]) - curV;
-		  normArray[curElem->vertexNumber] = normArray[curElem->vertexNumber] + nextV.cross(prevV);
-
-		  prevElem = curElem;
-		  curElem = curElem->next;
-		}
-	    }
-	  tmpFace = tmpFace->next;
-	}
-      tmpGroup = tmpGroup->next;
-    }
-
-  for (int i=0; i<vertices->getCount()/3;i++)
-    {
-      normArray[i].normalize();
-      PRINTF(5)("Found Normale number %d: (%f; %f, %f).\n", i, normArray[i].x, normArray[i].y, normArray[i].z);
-      
-      this->normals->addEntry(normArray[i].x, normArray[i].y, normArray[i].z);
-
-    }
-  delete []normArray; 
-  
-}
-
 
 /**
@@ -833,10 +919,10 @@
   */
 
-  this->addFace (4, 3, 1,1,1, 2,2,2, 4,4,3, 3,3,4);
-  this->addFace (4, 3, 3,3,5, 4,4,6, 6,6,7, 5,5,8);
-  this->addFace (4, 3, 5,5,9, 6,6,10, 8,8,11, 7,7,12);
-  this->addFace (4, 3, 7,7,13, 8,8,14, 2,10,15, 1,9,16);
-  this->addFace (4, 3, 2,2,17, 8,11,18, 6,12,19, 4,4,20);
-  this->addFace (4, 3, 7,13,21, 1,1,22, 3,3,23, 5,14,24);
-
-}
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 1,1,1, 2,2,2, 4,4,3, 3,3,4);
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 3,3,5, 4,4,6, 6,6,7, 5,5,8);
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 5,5,9, 6,6,10, 8,8,11, 7,7,12);
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 7,7,13, 8,8,14, 2,10,15, 1,9,16);
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 2,2,17, 8,11,18, 6,12,19, 4,4,20);
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 7,13,21, 1,1,22, 3,3,23, 5,14,24);
+
+}
Index: orxonox/branches/physics/src/lib/graphics/importer/model.h
===================================================================
--- orxonox/branches/physics/src/lib/graphics/importer/model.h	(revision 3866)
+++ orxonox/branches/physics/src/lib/graphics/importer/model.h	(revision 3953)
@@ -8,10 +8,19 @@
 
 #include "material.h"
+#include "glincl.h"
 
 // FORWARD DEFINITION //
 class Array;
 class Vector;
+template<class T> class tList;
 
-using namespace std;
+//! an enumerator fot the different Model Types.
+/**
+   MODEL_DISPLAY_LIST means, that a DisplayList will be built out of the model. This model will be STATIC, meaning it cannot be changed after initialisation.
+   MODEL_VERTEX_ARRAY means, that a VertexArray will be built out of the model. This moel will be DYNAMIX, meaning that one can change the properties from outside of the model.
+*/
+typedef enum MODEL_TYPE {MODEL_DISPLAY_LIST,
+			 MODEL_VERTEX_ARRAY};
+
 
 // definition of different modes for setting up Faces
@@ -19,24 +28,17 @@
 #define NORMAL 1       //!< If Faces are created WITH Normals (otherwise autocalculate)
 #define TEXCOORD 2     //!< If Faces are created WITH TextureCoordinate
+//! an enumerator for VERTEX_FORMAT
+typedef enum VERTEX_FORMAT {VERTEX_ONLY = VERTEX,
+		    VERTEX_NORMAL = NORMAL,
+		    VERTEX_TEXCOORD = TEXCOORD,
+		    VERTEX_TEXCOORD_NORMAL = NORMAL | TEXCOORD};
 
 //! Class that handles 3D-Models. it can also read them in and display them.
 class Model
 {
- public:
-  Model(void);
-  Model(char* modelName);
-  virtual ~Model(void);
-
-  void setName(const char* name);
-  
-  void draw(void) const;
-  void draw(int groupNumber) const;
-  void draw(char* groupName) const;
-  int getGroupCount() const;
-
- protected:
-  char* name;            //!< This is the name of the Model.
-  bool finalized;        //!< Sets the Object to be finalized.
-  
+ private:
+  /////////////
+  // structs //
+  /////////////
   //! This is the placeholder of one Vertex beloning to a Face.
   struct FaceElement
@@ -64,5 +66,6 @@
     char* name;         //!< the Name of the Group. this is an identifier, that can be accessed via the draw (char* name) function.
 
-    unsigned int listNumber;//!< The number of the GL-List this Group gets.
+    GLubyte* indices;   //!< The indices of the Groups. Needed for vertex-arrays
+    GLuint listNumber;  //!< The number of the GL-List this Group gets.
     Face* firstFace;    //!< The first Face in this group.
     Face* currentFace;  //!< The current Face in this Group (the one we are currently working with.)
@@ -73,4 +76,7 @@
   };
 
+  char* name;            //!< This is the name of the Model.
+  MODEL_TYPE type;
+  bool finalized;        //!< Sets the Object to be finalized.
 
   Array* vertices;      //!< The Array that handles the Vertices.
@@ -79,15 +85,22 @@
   Array* vTexture;      //!< The Array that handles the VertexTextureCoordinates.
 
-  
   Group* firstGroup;    //!< The first of all groups.
   Group* currentGroup;  //!< The currentGroup. this is the one we will work with.
   int groupCount;       //!< The Count of Groups.
 
-  Material* material;   //!< Initial pointer to the Material. This can hold many materials, because Material can be added with Material::addMaterial(..)
-  float scaleFactor;    //!< The Factor with which the Model should be scaled. \todo maybe one wants to scale the Model after Initialisation
+  tList<Material>* materialList;
+  
 
-  bool initialize(void);
   bool initGroup(Group* group);
   bool initFace (Face* face);
+
+  bool buildVertexNormals(void);
+
+  bool importToDisplayList(void);
+  bool addGLElement(FaceElement* elem);
+
+  bool importToVertexArray(void);
+
+  bool deleteArrays(void);
   bool cleanup(void);
   bool cleanupGroup(Group* group);
@@ -95,25 +108,39 @@
   bool cleanupFaceElement(FaceElement* faceElem);
 
- public:
-  bool addGroup(char* groupString);
-  bool addVertex(char* vertexString);
-  bool addVertex(const float x, const float y, const float z);
-  bool addFace(char* faceString);
-  bool addFace(const float faceElemCount, int type, ...);
-  bool addVertexNormal(char* normalString);
-  bool addVertexNormal(const float x, const float y, const float z);
-  bool addVertexTexture(char* vTextureString);
-  bool addVertexTexture(const float u, const float v);
-  bool addUseMtl(char* mtlString);
-  bool addUseMtl(Material* mtl);
-  void finalize(void);
 
  protected:
-  bool importToGL(void);
-  bool addGLElement(FaceElement* elem);
+  float scaleFactor;    //!< The Factor with which the Model should be scaled. \todo maybe one wants to scale the Model after Initialisation
 
-  bool buildVertexNormals(void);
+  Material* findMaterialByName(const char* materialName);
 
   void cubeModel(void);
+
+ public:
+  Model(const char* modelName = NULL, MODEL_TYPE type = MODEL_DISPLAY_LIST);
+  virtual ~Model(void);
+
+  void setName(const char* name);
+  inline const char* getName() {return this->name;}
+  
+  void draw(void) const;
+  void draw(int groupNumber) const;
+  void draw(char* groupName) const;
+  int getGroupCount() const;
+
+  Material* addMaterial(Material* material);
+  Material* addMaterial(const char* materialName);
+
+  bool addGroup(const char* groupString);
+  bool addVertex(const char* vertexString);
+  bool addVertex(float x, float y, float z);
+  bool addFace(const char* faceString);
+  bool addFace(int faceElemCount, VERTEX_FORMAT type, ...);
+  bool addVertexNormal(const char* normalString);
+  bool addVertexNormal(float x, float y, float z);
+  bool addVertexTexture(const char* vTextureString);
+  bool addVertexTexture(float u, float v);
+  bool setMaterial(const char* mtlString);
+  bool setMaterial(Material* mtl);
+  void finalize(void);
 };
 
